package com.sun.corba.se.impl.transport;

import com.sun.corba.se.spi.transport.SocketInfo;
import java.util.Iterator;
import com.sun.corba.se.spi.ior.iiop.IIOPAddress;
import com.sun.corba.se.spi.ior.iiop.AlternateIIOPAddressComponent;
import com.sun.corba.se.spi.ior.iiop.IIOPProfileTemplate;
import java.util.ArrayList;
import java.util.List;
import com.sun.corba.se.spi.ior.IOR;
import com.sun.corba.se.spi.transport.IORToSocketInfo;

public class DefaultIORToSocketInfoImpl implements IORToSocketInfo
{
    public DefaultIORToSocketInfoImpl() {
    }
    
    public List getSocketInfo(IOR ior) {
        ArrayList<SocketInfo> list = new ArrayList();
        IIOPProfileTemplate iiopProfileTemplate = (IIOPProfileTemplate)ior.getProfile().getTaggedProfileTemplate();
        IIOPAddress primaryAddress = iiopProfileTemplate.getPrimaryAddress();
        list.add(this.createSocketInfo(primaryAddress.getHost().toLowerCase(), primaryAddress.getPort()));
        Iterator<Object> iteratorById = iiopProfileTemplate.iteratorById(3);
        while (iteratorById.hasNext()) {
            AlternateIIOPAddressComponent alternateIIOPAddressComponent = (AlternateIIOPAddressComponent)iteratorById.next();
            list.add(this.createSocketInfo(alternateIIOPAddressComponent.getAddress().getHost().toLowerCase(), alternateIIOPAddressComponent.getAddress().getPort()));
        }
        return list;
    }
    
    private SocketInfo createSocketInfo(final String s, final int n) {
        return new SocketInfo() {
            public String getType() {
                return "IIOP_CLEAR_TEXT";
            }
            
            public String getHost() {
                return s;
            }
            
            public int getPort() {
                return n;
            }
        };
    }
}
